<?php
namespace Teknisa\FIN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class ProdutoTipoctpagarTipoctreceber extends \Teknisa\FIN\Controllers\TeknisaCrud {
    protected $dataSourceName = "produto_tipoctpagar_tipoctreceber";
    protected $dataSourceNameToSave = "produto";
    protected $parameterBagColumns = array('P_CDPRODINI', 'P_CDPRODFIN');

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $conditions     = $filterCriteria->getConditions();

        //uncomment lines when Zeedhi Framework manage to get faster
            if(count($conditions) == 2) {
            if($conditions[0]['columnName'] == 'P_CDPRODINI' && $conditions[1]['columnName'] == 'P_CDPRODFIN')
                $filterCriteria->addCondition("CDPRODNIVANTE", "IS_NULL", null);
        } 
        parent::find($request, $response);

        $dataSets = $response->getDataSets();
        $rows = $dataSets[0]->getRows();
        
         $rows = array_map(function($row) {
            $columnName = isset($row['HASCHILD'])? 'HASCHILD' : 'PAI';
            $row['_hasChild'] = $row[$columnName] === 'true' ? true : false;
            unset($row[$columnName]);
            return $row;
        }, $rows); 
        
        $response->setDataSets(array(new DataSet('products', $rows)));
    }
}