<?php
/**
 * Created by PhpStorm.
 * User: carinaoliveira
 * Date: 04/08/14
 * Time: 12:32
 */

namespace Financeiro\Logic\ChequesRecebidos;

use Financeiro\Entities\Logchequerec;
use Financeiro\Entities\Chequerece;
use Financeiro\Entities\Movbancario;
use Financeiro\Entities\Baixarecebida;
use Financeiro\Entities\Boletreceber;
use Financeiro\Entities\Contareceber;
use \Financeiro\Logic\AtualizaFluxodeCaixa\FluxodeCaixa;

class ChequesRecebidos {

    //Insere no banco uma nova linha na tabela LOGCHEQUEREC
    public static function insereLogChequeRec($campos) {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {
            $where = "    NRCHEQUERECE =?
                      AND NRORG =?";

            $params = array($campos['NRCHEQUERECE'], $campos['NRORG']);

            $logschequesrece = Logchequerec::getObjectsByWhere($where, $params);

            if(count($logschequesrece) > 0) {
                $campos['NRLOGCHEQREC'] = count($logschequesrece) + 1;
                if($campos['NRLOGCHEQREC'] < 10) {
                    $campos['NRLOGCHEQREC'] = '0'.$campos['NRLOGCHEQREC'];
                }
            }
            else {
                $campos['NRLOGCHEQREC'] = '01';
            }

            $logchequerece = new Logchequerec();

            $logchequerece->setNrchequerece($campos['NRCHEQUERECE']);
            $logchequerece->setCdbancheqrec($campos['CDBANCHEQREC']);
            $logchequerece->setCdagecheqrec($campos['CDAGECHEQREC']);
            $logchequerece->setCdcntcheqrec($campos['CDCNTCHEQREC']);
            $logchequerece->setNrlogcheqrec($campos['NRLOGCHEQREC']);
            $logchequerece->setDtaprcheqrec($campos['DTAPRCHEQREC']);
            $logchequerece->setDtdevcheqrec($campos['DTDEVCHEQREC']);
            $logchequerece->setDsobscheqrec($campos['DSOBSCHEQREC']);
            $logchequerece->setCdopeborcrec($campos['CDOPEBORCREC']);
            $logchequerece->setNrbordercrec($campos['NRBORDERCREC']);
            $logchequerece->setDtbordercrec($campos['DTBORDERCREC']);
            $logchequerece->setNrorg($campos['NRORG']);
            $logchequerece->setIdativo($campos['IDATIVO']);
            $logchequerece->setDtultatu($campos['DTULTATU']);
            $logchequerece->setCdoperultatu($campos['CDOPERULTATU']);
            $logchequerece->setNrorgultatu($campos['NRORGULTATU']);
            $logchequerece->setDtinclusao($campos['DTINCLUSAO']);
            $logchequerece->setCdoperinclusao($campos['CDOPERINCLUSAO']);
            $logchequerece->setNrorginclusao($campos['NRORGINCLUSAO']);

            $logchequerece->persist();

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }

    //Função que atualiza no banco o status do Cheque
    public static function atualizaStatusChequeRece($nrcheque, $cdbancocheque, $cdagenciacheque, $cdcontcorr, $nrorg, $statusChequerece) {

        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {
            $where = "    NRCHEQUERECE =?
                      AND CDBANCHEQREC = ?
                      AND CDAGECHEQREC = ?
                      AND CDCNTCHEQREC = ?
                      AND NRORG = ?";

            $params = array($nrcheque, $cdbancocheque, $cdagenciacheque, $cdcontcorr, $nrorg);

            $chequerece = Chequerece::getObjectsByWhere($where, $params);

            $chequerece[0]->setIdsitcheqrec($statusChequerece);

            $chequerece[0]->persist();

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }

    //Função que atualiza no banco a data de compensação do Cheque
    public static function atualizaDtCompChequeRece($nrcheque, $cdbancocheque, $cdagenciacheque, $cdcontcorr, $nrorg, $dataCompen) {

        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {
            $where = "    NRCHEQUERECE =?
                      AND CDBANCHEQREC = ?
                      AND CDAGECHEQREC = ?
                      AND CDCNTCHEQREC = ?
                      AND NRORG = ?";

            $params = array($nrcheque, $cdbancocheque, $cdagenciacheque, $cdcontcorr, $nrorg);

            $chequerece = Chequerece::getObjectsByWhere($where, $params);

            $chequerece[0]->setDtcomcheqrec($dataCompen);

            $chequerece[0]->persist();

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }

    //Função que insere no banco um novo registro na tabela MOVBANCARIO
    public static function insereMovBancario($camposMovBanc) {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {

            $movBancario = new Movbancario();

            $movBancario->setCdreducont($camposMovBanc['CDREDUCONT']);
            $movBancario->setNrmovbanc($camposMovBanc['NRMOVBANC']);
            $movBancario->setDtmovbanc($camposMovBanc['DTMOVBANC']);
            $movBancario->setIdmovbanc($camposMovBanc['IDMOVBANC']);
            $movBancario->setDshismbanc($camposMovBanc['DSHISMBANC']);
            $movBancario->setVrmovbanc($camposMovBanc['VRMOVBANC']);
            $movBancario->setIdorigmbanc($camposMovBanc['IDORIGMBANC']);
            $movBancario->setIdstconext($camposMovBanc['IDSTCONEXT']);
            $movBancario->setIdstatusctbbanc($camposMovBanc['IDSTATUSCTBBANC']);
            $movBancario->setNrorg($camposMovBanc['NRORG']);
            $movBancario->setDtultatu($camposMovBanc['DTULTATU']);
            $movBancario->setCdoperultatu($camposMovBanc['CDOPERULTATU']);
            $movBancario->setNrorgultatu($camposMovBanc['NRORGULTATU']);
            $movBancario->setDtinclusao($camposMovBanc['DTINCLUSAO']);
            $movBancario->setCdoperinclusao($camposMovBanc['CDOPERINCLUSAO']);
            $movBancario->setNrorginclusao($camposMovBanc['NRORGINCLUSAO']);

            $movBancario->persist();

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }

    //Função que insere no banco um novo registro na tabela BAIXARECEBIDA
    public static function insereBaixaRecebida($camposBaixaRece) {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {

            $baixaRecebida = new Baixarecebida();

            $baixaRecebida->setCdfilial($camposBaixaRece['CDFILIAL']);
            $baixaRecebida->setNrbaixarec($camposBaixaRece['NRBAIXAREC']);
            $baixaRecebida->setCdempresa($camposBaixaRece['CDEMPRESA']);
            $baixaRecebida->setNrmovbanc($camposBaixaRece['NRMOVBANC']);
            $baixaRecebida->setDtbaixarec($camposBaixaRece['DTBAIXAREC']);
            $baixaRecebida->setVrbaixarec($camposBaixaRece['VRBAIXAREC']);
            $baixaRecebida->setCdreducont($camposBaixaRece['CDREDUCONT']);
            $baixaRecebida->setIdstatusbrec($camposBaixaRece['IDSTATUSBREC']);
            $baixaRecebida->setIdstatusctbrec($camposBaixaRece['IDSTATUSCTBREC']);
            $baixaRecebida->setNrorg($camposBaixaRece['NRORG']);
            $baixaRecebida->setDtultatu($camposBaixaRece['DTULTATU']);
            $baixaRecebida->setCdoperultatu($camposBaixaRece['CDOPERULTATU']);
            $baixaRecebida->setNrorgultatu($camposBaixaRece['NRORGULTATU']);
            $baixaRecebida->setDtinclusao($camposBaixaRece['DTINCLUSAO']);
            $baixaRecebida->setCdoperinclusao($camposBaixaRece['CDOPERINCLUSAO']);
            $baixaRecebida->setNrorginclusao($camposBaixaRece['NRORGINCLUSAO']);

            $baixaRecebida->persist();

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }

    //Função que atualiza no banco um registro na tabela BOLETRECEBER
    public static function atualizaBoletoReceb($camposBoleto) {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {

            $boletosRecebidos = Boletreceber::getRepository()->consultaBoletosRec($camposBoleto['NRCHEQUERECE'],$camposBoleto['CDBANCHEQREC'],$camposBoleto['CDAGECHEQREC'],$camposBoleto['CDCNTCHEQREC'], $camposBoleto['NRORG']);

            foreach($boletosRecebidos as $boletoRecebido) {
                $boleto = Boletreceber::findOneByCdfilialAndNrlanbolrecAndNrorg($boletoRecebido['CDFILIAL'], $boletoRecebido['NRLANBOLREC'], $camposBoleto['NRORG']);

                $boleto->setNrbaixarec($camposBoleto['NRBAIXAREC']);
                $boleto->setIdstatbrec($camposBoleto['IDSTATBREC']);
                $boleto->setCdtpbaixarec($camposBoleto['CDTPBAIXAREC']);
                $boleto->setDtultatu($camposBoleto['DTULTATU']);
                $boleto->setCdoperultatu($camposBoleto['CDOPERULTATU']);
                $boleto->setNrorgultatu($camposBoleto['NRORGULTATU']);

                $boleto->persist();
            }

            $connection->flush();
            $db->commit();

        }
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }
    }

    //Função que atualiza no banco um registro na tabela CONTARECEBER
    public static function atualizaContaReceber($camposContaRec) {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {

            $boletosRecebidos = Boletreceber::getRepository()->consultaBoletosRec($camposContaRec['NRCHEQUERECE'],$camposContaRec['CDBANCHEQREC'],$camposContaRec['CDAGECHEQREC'],$camposContaRec['CDCNTCHEQREC'], $camposContaRec['NRORG']);

            foreach($boletosRecebidos as $boletoRecebido) {

                $contasrecebidas = Contareceber::findByCdfilibolrecAndNrlanbolrecAndNrorg($boletoRecebido['CDFILIAL'], $boletoRecebido['NRLANBOLREC'],$camposContaRec['NRORG']);

                foreach($contasrecebidas as $contaRec) {
                    $contaRec->setIdstatrec($camposContaRec['IDSTATREC']);
                    $contaRec->persist();

                    //Gerar movimentação de fluxo de caixa

                    $valorConta  = $contaRec->getVrorigrec();
                    $cdfilial    = $contaRec->getCdfimovflrec();
                    $cdclassFina = $contaRec->getCdclassfina();
                    $dtMovFluxo  = $contaRec->getDtmovfluxo();

                    FluxodeCaixa::atualizaFluxo(
                        $camposContaRec['CDEMPRESA'], $cdfilial, $cdclassFina, $dtMovFluxo, $valorConta*(-1), 'E', 'E'
                    );
                    FluxodeCaixa::atualizaFluxo(
                        $camposContaRec['CDEMPRESA'], $cdfilial, $cdclassFina, $dtMovFluxo, $valorConta, 'R', 'E'
                    );

                }
            }

            $connection->flush();
            $db->commit();

        }
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }
    }

} 