/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_PROD                                                    */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao do Produto                           */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PROD'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_PROD
  GO

CREATE TRIGGER DTULTATU_PROD
ON PRODUTO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODUTO', 'CDPRODUTO=' + CDPRODUTO+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODUTO
      SET DTULTATUPROD = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE
         (ISNULL(PRODUTO.CDPRODUTO   ,0) = ISNULL(INSERTED.CDPRODUTO   ,0));
         
      UPDATE PRODWEBSYNC
      SET DTULTALTPROD = GETDATE(), IDATUALIZADO = 'N'
      FROM INSERTED
      WHERE (ISNULL(PRODUTO.NMPRODUTO ,0) = ISNULL(INSERTED.NMPRODUTO ,0)) AND
            (ISNULL(PRODUTO.DSOBSNUTR ,0) = ISNULL(INSERTED.DSOBSNUTR ,0)) AND
            (ISNULL(PRODUTO.CDARVPROD ,0) = ISNULL(INSERTED.CDARVPROD ,0)) AND
            (PRODWEBSYNC.CDPRODUTO = INSERTED.CDPRODUTO);
   END;
END;
GO

UPDATE PRODUTO SET DTULTATUPROD = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPROD IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPROD' and
            type = 'D')
   ALTER TABLE PRODUTO DROP CONSTRAINT DEFAULT_DTULTATUPROD
GO

ALTER TABLE PRODUTO ADD CONSTRAINT DEFAULT_DTULTATUPROD
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPROD
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PROD','5.05.023';
GO