var Pag18000_CompensacaoContaPagar_Controller = function(ScreenService, templateManager, General, ZHPromise, ZhFilterPreferences) {

    var wasFiltered = false;
    /*
     * Gets e Sets
     */
     
    this.openFilterCompensacao = function(compensacaoContasPagar){
        var data = moment().format('DD/MM/YYYY');
        var rowFilter = {'DTLANCCOMPPAG': {start : data, end : data}};
        ZhFilterPreferences.setOriginalFilter(compensacaoContasPagar.id, rowFilter);
        ZhFilterPreferences.openFilterWidget(compensacaoContasPagar, rowFilter);
    };

    this.validaDatasBaixaCompensacao = function(widget, fieldClear){
        var arrayBaixa = widget.currentRow.DTBAIXACOMP.split('/');
        var arrayComp = widget.currentRow.DTCOMPENCTPAG.split('/');
        var anoBaixa = arrayBaixa.pop();
        var mesBaixa = arrayBaixa.pop();
        var diaBaixa = arrayBaixa.pop();
        var anoComp = arrayComp.pop();
        var mesComp = arrayComp.pop();
        var diaComp = arrayComp.pop();
        var dataBaixa = parseInt(anoBaixa.concat(mesBaixa.concat(diaBaixa)));
        var dataCompensacao = parseInt(anoComp.concat(mesComp.concat(diaComp)));
        if (dataBaixa <= dataCompensacao){
            ScreenService.showMessage('Data da baixa deve ser igual ou maior à data da compensação.');
            fieldClear.setValue('');
        }
    };

    this.adicionaCompensacao = function(widget){
        this.novaCompensacao(widget).then(function(){
            this.validaItemCompensacao(widget);
        }.bind(this));
    };

    this.novaCompensacao = function(widget){
        var deferred = ZHPromise.defer();
        General.widgetNewRow(widget);
        widget.getField('IDTPITUTLCOMPAG').setValue('0');
        widget.getField('CONTARECEBER').isVisible = true;
        widget.getField('CONTACORRENTE').isVisible = true;
        widget.getField('CONTAPAGAR').isVisible = true;
        widget.getField('VRTOTALCOMPPAG').class = '3';
        widget.getField('SOMACONTACORRENTE').class = '3';
        templateManager.container.getWidget('TitulosCompensadosReceber').isVisible = false;
        templateManager.container.getWidget('ContasCorrentesCompensadas').isVisible = false;
        deferred.resolve();
        return deferred.promise;
    };

    this.cancelaCompensacao = function(widget){
        General.widgetCancelForm(widget);
        widget.getField('CONTARECEBER').isVisible = false;
        widget.getField('CONTACORRENTE').isVisible = false;
        widget.getField('CONTAPAGAR').isVisible = false;
        widget.getField('VRTOTALCOMPPAG').class = '12';
        widget.getField('SOMACONTACORRENTE').class = '12';
        templateManager.container.getWidget('TitulosCompensadosReceber').isVisible = true;
        templateManager.container.getWidget('ContasCorrentesCompensadas').isVisible = true;
    };

    this.getEmpresa = function () {
        return templateManager.container.getWidget('CompensacaoContasReceber').currentRow.CDEMPRESA;
    };

    this.getFilial = function () {
        return templateManager.container.getWidget('CompensacaoContasReceber').currentRow.CDFILIAL;
    };

    this.getNrorg = function () {
        return templateManager.container.getWidget('CompensacaoContasReceber').currentRow.NRORG;
    };

    /*
     * Validações de FrontEnd
     */

    this.aplicaFiltroCompensacaoPagar = function () {
        var compensacao = templateManager.container.getWidget('CompensacaoContasPagar');
        var filtro = compensacao.appliedFilter;
        var operador = '';
        var cdforneced = '';
        if (filtro.FILTER_ROW.hasOwnProperty('DTLANCCOMPPAG')){
            if (filtro.FILTER_ROW.DTLANCCOMPPAG.hasOwnProperty('start')){
                var lancIni = filtro.FILTER_ROW.DTLANCCOMPPAG.start;
                var lancFin = filtro.FILTER_ROW.DTLANCCOMPPAG.end;
            }
        }
        if (filtro.FILTER_ROW.hasOwnProperty('DTCOMPENCTPAG')){
            if (filtro.FILTER_ROW.DTCOMPENCTPAG.hasOwnProperty('start')){
                var compIni = filtro.FILTER_ROW.DTCOMPENCTPAG.start;
                var compFin = filtro.FILTER_ROW.DTCOMPENCTPAG.end;
            }
        }
        var operadorMulti = filtro.FILTER_ROW.CDOPERADOR;
        var fornecedorMulti = filtro.FILTER_ROW.CDFORNECED;
        if (operadorMulti) {
            operadorMulti.forEach(function (filter) {
                operador += "_" + filter;
            });
            operador += "_";
        }
        if (fornecedorMulti) {
            fornecedorMulti.forEach(function (filter) {
                cdforneced += "_" + filter;
            });
            cdforneced += "_";
        }
        compensacao.dataSourceFilter.forEach(function (data) {
            switch (data.name) {
                case 'CDEMPRESA':
                    data.value = filtro.FILTER_ROW.CDEMPRESA;
                    break;
                case 'CDOPERADOR':
                    data.value = operador;
                    break;
                case 'TCDOPERADOR':
                    data.value = (operador) ? null : 'T';
                    break;
                case 'CDFORNECED':
                    data.value = cdforneced;
                    break;
                case 'TCDFORNECED':
                    data.value = (cdforneced) ? null : 'T';
                    break;
                case 'DTCOMPENSACAO_INI': data.value = compIni;
                    break;
                case 'DTCOMPENSACAO_FIN': data.value = compFin;
                    break;
                case 'TCOMPENSACAO': data.value = (compIni && compFin) ? null : 'T';
                    break;
                case 'DTLANCAMENTO_INI': data.value = lancIni;
                    break;
                case 'DTLANCAMENTO_FIN': data.value = lancFin;
                    break;
                case 'TLANCAMENTO': data.value = (lancIni && lancFin) ? null : 'T';
                    break;
            }
        });
    };


    this.validaCamposAtivos = function (args) {
        var field = args.owner.field.name;
        var row = args.owner.field.widget.currentRow;

        switch (field) {
            case 'NMEMPRESA':
                args.owner.field.widget.getField('NMRAZSOCFORN').readOnly = !row.NMEMPRESA;
                args.owner.field.widget.getField('NMTPBAIXAREC').readOnly = !row.NMEMPRESA;
                args.owner.field.widget.getField('DSAJUCTREC').readOnly = !row.NMEMPRESA;
                args.owner.field.widget.getField('CONTACORRENTE').readOnly = !row.NMEMPRESA;
                args.owner.field.widget.getField('CONTARECEBER').readOnly = !row.NMEMPRESA;
                break;
            case 'NMRAZSOCFORN':
                args.owner.field.widget.getField('CONTAPAGAR').readOnly = !row.NMRAZSOCFORN;
                if ((row.CDFORNECED != args.owner.field.widget.FORNECEDOR) && (row.CDFORNECED)){
                    row.CONTAPAGAR = null;
                    row.DTVENBOLPAG = null;
                    row.DOCUMENTO = null;
                    row.NRINSJURFORN = null;
                    row.NRSEQVENPAG = null;
                    row.NRPARCELAPAG = null;
                    row.VRORIGPAG = null;
                    row.VRFINALBPAG = null;
                }
                args.owner.field.widget.getField('CONTAPAGAR').readOnly = !row.NMRAZSOCFORN;
                break;
            case 'CDREDUCONT':
                args.owner.field.widget.getField('CONTACORRENTE').readOnly = !row.CDREDUCONT;
                break;
            default:
                var aux = 'teste';
        }
    };

    this.setValueAntFornecedor = function (widget){
        widget.FORNECEDOR = widget.currentRow.CDFORNECED;
    };

    this.validaItemCompensacao = function (widget) {
        if (widget.currentRow.IDTPITUTLCOMPAG == '0') {
            widget.fieldGroups.forEach(function (group) {
                if (group.name == 'contaReceber') {
                    group.isVisible = true;
                    widget.getField('CONTACORRENTE').validations = null;
                    widget.getField('CONTARECEBER').validations = {'required': {'message': 'Campo obrigatório'}};
                    widget.getField('NMTPBAIXAREC').validations = {'required': {'message': 'Campo obrigatório'}};
                    widget.getField('DSAJUCTREC').validations = {'required': {'message': 'Campo obrigatório'}};
                }
                if (group.name == 'creditoContaCorrente') {
                    group.isVisible = false;
                }
            });
        } else {
            widget.fieldGroups.forEach(function (group) {
                if (group.name == 'contaReceber') {
                    group.isVisible = false;
                }
                if (group.name == 'creditoContaCorrente') {
                    group.isVisible = true;
                    widget.getField('CONTACORRENTE').validations = {'required': {'message': 'Campo obrigatório'}};
                    widget.getField('CONTARECEBER').validations = null;
                    widget.getField('NMTPBAIXAREC').validations = null;
                    widget.getField('DSAJUCTREC').validations = null;
                }
            });
        }
    };

    this.validaTipoCompensacao = function(widget){
        var receberCompensados = templateManager.container.getWidget('TitulosCompensadosReceber');
        var contasCompensadas = templateManager.container.getWidget('ContasCorrentesCompensadas');
        if (widget.currentRow.IDTPITUTLCOMPAG == '0'){
            receberCompensados.isVisible = true;
            receberCompensados.enabled = true;
            contasCompensadas.isVisible = false;
            this.setFiltroTitulosRecCompensados(widget, receberCompensados).then(function(){
                receberCompensados.reload();
            });
        }else{
            contasCompensadas.isVisible = true;
            contasCompensadas.enabled = true;
            receberCompensados.isVisible = false;
            this.setFiltroContasCorrentesCompensadas(widget, contasCompensadas).then(function(){
                contasCompensadas.reload();
            });
        }
    };

    this.setFiltroTitulosRecCompensados = function (widget, receberCompensados) {
        var deferred = ZHPromise.defer();
        receberCompensados.dataSourceFilter.forEach(function (data) {
            switch(data.name) {
                case 'NRLANCCOMPPAG': data.value = widget.currentRow.NRLANCCOMPPAG;
                    break;
                case 'CDEMPRESA': data.value = widget.currentRow.CDEMPRESA;
                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    this.setFiltroContasCorrentesCompensadas = function (widget, contasCompensadas) {
        var deferred = ZHPromise.defer();
        contasCompensadas.dataSourceFilter.forEach(function (data) {
            switch(data.name) {
                case 'NRLANCCOMPPAG': data.value = widget.currentRow.NRLANCCOMPPAG;
                    break;
                case 'CDREDUCONT': data.value = widget.currentRow.CDREDUCONT;
                    break;
                case 'NRORG': data.value = widget.currentRow.NRORG;
                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };
    this.validaFieldLancContaCorrente = function (args) {
        /*var field = args.owner.field.name;

         switch(field) {
         case 'CDREDUCONT':
         var row = args.owner.field.widget.currentRow;
         args.owner.field.widget.getField('CONTACORRENTE').readOnly = !row.CDREDUCONT;
         break;
         default:
         var aux = 'teste';
         }*/
    };

    this.validaValorTotalPagar = function (origin) {
        /*try{
         var widget = templateManager.container.getWidget('CompensacaoContasReceber');

         var somaTotal = 0;
         var VRORIGPAG = widget.currentRow.CP_VRORIGPAG;

         if (VRORIGPAG) {
         for (var i=0; i<VRORIGPAG.length; i++) {
         somaTotal = somaTotal + VRORIGPAG[i];
         }
         };

         widget.currentRow.VRTOTALCOMREC = somaTotal;

         if(somaTotal > widget.currentRow.VRORIGREC){
         if(origin){
         ScreenService.showMessage("Valor total a compensar deve ser menor ou igual ao valor líquido da conta a receber.");
         }
         return false;
         }else{
         return true;
         }

         }catch(e){
         ScreenService.showMessage("Valor total a compensar deve ser menor ou igual ao valor líquido da conta informada.");
         }*/
    };

    this.getDefaulInterval = function () {
        var obj = {
            "start": moment().startOf('month').format('DD/MM/YYYY'),
            "end": moment().endOf('month').format('DD/MM/YYYY')
        };
        return obj;
    };

    /*
     * Fim Validações de FrontEnd
     */

    this.deleteCompensacao = function (widget) {
        var route = 'fin_contaPagar#/deleteCompensacaoPagar/delete';
        var dataSet = [];
        dataSet = this.preparaRowDeleteCompensacao(widget, dataSet);
        if (widget.currentRow.IDTPITUTLCOMPAG == '0'){
            var widgetTitulos = templateManager.container.getWidget('TitulosCompensadosReceber');
            this.preparaRowDeleteTitulos(widgetTitulos, dataSet);
        }else{
            var widgetContas = templateManager.container.getWidget('ContasCorrentesCompensadas');
            this.preparaRowDeleteContas(widgetContas, dataSet);
        }
        ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir Compensação?'), 'question', function () {
            General.callRestEngine(route, 'DataSet', dataSet)
                .then(function () {
                    ScreenService.closeSwipe().then(function(){
                        widget.reload();
                        ScreenService.showMessage('Registro excluído com sucesso!');
                    });
                })
                .catch(function (response) {
                    ScreenService.showMessage(response.data.error);
                });
        });
    };

    this.preparaRowDeleteTitulos = function(widget, dataSet){
        widget.dataSource.data.forEach(function(data){
            var indice = dataSet.length;
            dataSet[indice] = {};
            dataSet[indice].CDFILIAL = data.CDFILIAL;
            dataSet[indice].NRLANBOLREC = data.NRLANBOLREC;
            dataSet[indice].CDFILIBOLREC = data.CDFILIBOLREC;
            dataSet[indice].VRFINALBREC = data.VRFINALBREC;
            dataSet[indice].CDEMPRESA = data.CDEMPRESA;
            dataSet[indice].CDFIMOVFLREC = data.CDFIMOVFLREC;
            dataSet[indice].CDCLASSFINA = data.CDCLASSFINA;
            dataSet[indice].CDFILIAL = data.CDFILIAL;
            dataSet[indice].NRLANCTONF = data.NRLANCTONF;
            dataSet[indice].NRSEQVENREC = data.NRSEQVENREC;
            dataSet[indice].NRPARCELAREC = data.NRPARCELAREC;
            dataSet[indice].VRORIGREC = data.VRORIGREC;
            dataSet[indice].VRITEMCOMPPAG = data.VRITEMCOMPPAG;
            dataSet[indice].DTMOVFLUXO = data.DTMOVFLUXO;
        });
        return dataSet;
    };

    this.preparaRowDeleteContas = function(widget, dataSet){
        widget.dataSource.data.forEach(function(data){
            var indice = dataSet.length;
            dataSet[indice] = {};
            dataSet[indice].CDREDUCONT = data.CDREDUCONT;
            dataSet[indice].NRMOVIDEBI = data.NRMOVIDEBI;
        });
        return dataSet;
    };

    this.preparaRowDeleteCompensacao = function(widget, dataSet){
        var indice = dataSet.length;
        dataSet[indice] = {};
        dataSet[indice].VRFINALBPAG = widget.currentRow.VRFINALBPAG;
        dataSet[indice].CDFILIBPAG = widget.currentRow.CDFILIBPAG;
        dataSet[indice].NRLANBOLPAG = widget.currentRow.NRLANBOLPAG;
        dataSet[indice].VRTOTALCOMPPAG = widget.currentRow.VRTOTALCOMPPAG;
        dataSet[indice].CDAJUCTPAG = widget.currentRow.CDAJUCTPAG;
        dataSet[indice].CDAJUCTREC = widget.currentRow.CDAJUCTREC;
        dataSet[indice].CDFIMOVFLPAG = widget.currentRow.CDFIMOVFLPAG;
        dataSet[indice].CDCLASSFINA = widget.currentRow.CDCLASSFINA;
        dataSet[indice].CDFILIAL = widget.currentRow.CDFILIAL;
        dataSet[indice].NRLANCTONF = widget.currentRow.NRLANCTONF;
        dataSet[indice].NRSEQVENPAG = widget.currentRow.NRSEQVENPAG;
        dataSet[indice].NRPARCELAPAG = widget.currentRow.NRPARCELAPAG;
        dataSet[indice].VRBOLPAG = widget.currentRow.VRBOLPAG;
        dataSet[indice].DTMOVFLUXO = widget.currentRow.DTMOVFLUXO;
        dataSet[indice].NRORG = widget.currentRow.NRORG;
        dataSet[indice].DTBAIXACOMP = widget.currentRow.DTBAIXACOMP;
        dataSet[indice].NRBAIXAPAG = widget.currentRow.NRBAIXAPAG;
        dataSet[indice].FILIPROC = widget.currentRow.FILIPROC;
        dataSet[indice].CDTPBAIXAPAG = widget.currentRow.CDTPBAIXAPAG;
        dataSet[indice].IDTPITUTLCOMPAG = widget.currentRow.IDTPITUTLCOMPAG;
        dataSet[indice].NRLANCCOMPPAG = widget.currentRow.NRLANCCOMPPAG;
        dataSet[indice].NRLCTBBPAG = widget.currentRow.NRLCTBBPAG;
        dataSet[indice].CDFILIBAIXAREC = widget.currentRow.CDFILIBAIXAREC;
        dataSet[indice].NRBAIXAREC = widget.currentRow.NRBAIXAREC;
        dataSet[indice].NRLCTBBREC = widget.currentRow.NRLCTBBREC;
        dataSet[indice].CDEMPRESA = widget.currentRow.CDEMPRESA;
        return dataSet;
    };

    this.saveCompensacao = function (widget) {
        var route = 'fin_contaPagar#/saveCompensacaoPagar/save';
        var dataSet = [];
        var valorCompensar = 0;

        if (widget.isValid())
        {
            dataSet = this.preparaRowCompensacaoPagar(widget, dataSet);
            var valorContaPagar = parseFloat(widget.currentRow.VRFINALBPAG);
            //Verifica se compensa com lançamentos em conta ou contas a receber.
            if (widget.currentRow.IDTPITUTLCOMPAG == '0') {
                valorCompensar = parseFloat(widget.currentRow.VRTOTALCOMPPAG);
                dataSet = this.preparaRowContasReceber(widget, dataSet);
            } else {
                valorCompensar = parseFloat(widget.currentRow.SOMACONTACORRENTE);
                dataSet = this.preparaRowLancamentoReceber(widget, dataSet);
            }
            if (valorCompensar != '0'){
                if (valorCompensar <= valorContaPagar){
                    General.callRestEngine(route, 'DataSet', dataSet)
                    .then(
                        function () {
                            widget.getField('CONTARECEBER').isVisible = false;
                            widget.getField('CONTAPAGAR').isVisible = false;
                            widget.getField('CONTACORRENTE').isVisible = false;
                            widget.getField('VRTOTALCOMPPAG').class = '12';
                            widget.getField('SOMACONTACORRENTE').class = '12';
                            ScreenService.closeSwipe().then(function(){
                                widget.reload();
                                ScreenService.showMessage('Registro salvo com sucesso!');
                            });
                        }
                    )
                    .catch(
                        function(erro){
                            ScreenService.showMessage(erro.data.error);
                        }
                    );
                }else{
                    ScreenService.showMessage("Valor total a compensar deve ser menor ou igual ao valor líquido da conta informada.");
                }
            }else{
                ScreenService.showMessage("Valor total a compensar deve ser maior que zero.");
            }
        }
    };

    this.preparaRowCompensacaoPagar = function (widget, dataSetPagar) {
        var empresa = widget.currentRow.CDEMPRESA;
        dataSetPagar[0] = {};
        dataSetPagar[0].__is_new = widget.currentRow.__is_new;
        dataSetPagar[0].changed = widget.currentRow.hasOwnProperty('changed');
        dataSetPagar[0].DOCUMENTO = widget.currentRow.DOCUMENTO;
        dataSetPagar[0].CDFORNECED = widget.currentRow.CDFORNECED;
        dataSetPagar[0].NRINSFURFORN = widget.currentRow.NRINSFURFORN;
        dataSetPagar[0].NRSEQVENPAG = widget.currentRow.NRSEQVENPAG;
        dataSetPagar[0].NRPARCELAPAG = widget.currentRow.NRPARCELAPAG;
        dataSetPagar[0].VRORIGINAL = widget.currentRow.VRORIGINAL;
        dataSetPagar[0].VRLIQUIDO = widget.currentRow.VRLIQUIDO;
        dataSetPagar[0].VRORIGPAG = widget.currentRow.VRORIGPAG;
        dataSetPagar[0].VRFINALBPAG = widget.currentRow.VRFINALBPAG;
        dataSetPagar[0].CDFIMOVFLPAG = widget.currentRow.CDFIMOVFLPAG;
        dataSetPagar[0].CDCLASSFINA = widget.currentRow.CDCLASSFINA;
        dataSetPagar[0].DTMOVFLUXO = widget.currentRow.DTMOVFLUXO;
        dataSetPagar[0].CDEMPRESA = empresa;
        dataSetPagar[0].NMFILIAL = widget.currentRow.NMFILIAL;
        dataSetPagar[0].CDFILIBPAG = widget.currentRow.CDFILIBPAG;
        dataSetPagar[0].NRLANBOLPAG = widget.currentRow.NRLANBOLPAG;
        dataSetPagar[0].IDTPINURFORN = widget.currentRow.IDTPINURFORN;
        dataSetPagar[0].CDFILIAL = widget.currentRow.CDFILIAL;
        dataSetPagar[0].NRLANCTONF = widget.currentRow.NRLANCTONF;
        dataSetPagar[0].CDTPBAIXAREC = widget.currentRow.CDTPBAIXAREC;
        dataSetPagar[0].DSBAIXAREC = widget.currentRow.NMTPBAIXAREC;
        dataSetPagar[0].CDTPBAIXAPAG = widget.currentRow.CDTPBAIXAPAG;
        dataSetPagar[0].CDAJUCTPAG = widget.currentRow.CDAJUCTPAG;
        dataSetPagar[0].CDREDUCONT = widget.currentRow.CDREDUCONT;
        dataSetPagar[0].DTBAIXACOMP = widget.currentRow.DTBAIXACOMP;
        dataSetPagar[0].IDTPITUTLCOMPAG = widget.currentRow.IDTPITUTLCOMPAG;
        dataSetPagar[0].CDAJUCTREC = widget.currentRow.CDAJUCTREC;
        if (widget.currentRow.IDTPITUTLCOMPAG == '0') {
            //Dados Conta Receber
            dataSetPagar[0].VRTOTALCOMPPAG = widget.currentRow.VRTOTALCOMREC;
            dataSetPagar[0].VRTOTALCOMPPAG = widget.currentRow.VRTOTALCOMPPAG;
        } else {
            //Dados Conta Receber
            dataSetPagar[0].VRTOTALCOMPPAG = widget.currentRow.SOMACONTACORRENTE;
        }
        return dataSetPagar;
    };

    this.preparaRowLancamentoReceber = function (widget, dataSet) {
        var empresa = widget.currentRow.CDEMPRESA;
        var contaCorrente = templateManager.container.getWidget('CompensacaoContasPagar').getField('CONTACORRENTE');
        contaCorrente.dataSource.getCheckedRows().forEach(function (data) {
            var indice = dataSet.length;
            dataSet[indice] = {};
            dataSet[indice].NRLANBOLREC = data.NRLANBOLREC;
            dataSet[indice].VRFINALBREC = data.VRFINALBREC;
            dataSet[indice].CDAJUCTREC = widget.currentRow.CDAJUCTREC;
            dataSet[indice].CDTPBAIXAREC = widget.currentRow.CDTPBAIXAREC;
            dataSet[indice].NRSEQVENREC = data.NRSEQVENREC;
            dataSet[indice].NRPARCELAREC = data.NRPARCELAREC;
            dataSet[indice].VRTOTALCOMPPAG = data.SOMACONTACORRENTE;
            dataSet[indice].IDLANCOMCONTPAG = data.IDLANCOMCONTPAG;
            dataSet[indice].CDREDUCONT= data.CDREDUCONT;
            dataSet[indice].NRMOVIDEBI= data.NRMOVIDEBI;
            dataSet[indice].VRMOVIDEBI= data.VRMOVIDEBI;
            dataSet[indice].CDFIMOVFLREC= data.CDFIMOVFLREC;
            dataSet[indice].CDEMPRESA = empresa;
        });
        return dataSet;
    };

    this.preparaRowContasReceber = function (widget, dataSet) {
        var empresa = widget.currentRow.CDEMPRESA;
        var contaReceber = templateManager.container.getWidget('CompensacaoContasPagar').getField('CONTARECEBER');
        contaReceber.dataSource.getCheckedRows().forEach(function (data) {
            var indice = dataSet.length;
            dataSet[indice] = {};
            dataSet[indice].CDEMPRESA = empresa;
            dataSet[indice].CDTPBAIXAREC = widget.currentRow.CDTPBAIXAREC;
            dataSet[indice].CDFILIAL = data.CDFILIAL;
            dataSet[indice].CDCLASSFINA = data.CDCLASSFINA;
            dataSet[indice].CDFILIBOLREC = data.CDFILIBOLREC;
            dataSet[indice].NRLANBOLREC = data.NRLANBOLREC;
            dataSet[indice].VRFINALBREC = data.VRFINALBREC;
            dataSet[indice].CDFIMOVFLREC = data.CDFIMOVFLREC;
            dataSet[indice].NRLANCTONF = data.NRLANCTONF;
            dataSet[indice].NRSEQVENREC = data.NRSEQVENREC;
            dataSet[indice].NRPARCELAREC = data.NRPARCELAREC;
            dataSet[indice].VRORIGREC = data.VRORIGREC;
            dataSet[indice].DTMOVFLUXO = moment().format('DD/MM/YYYY');
            dataSet[indice].NMRAZSOCCLIE = data.NMRAZSOCCLIE;
        });
        return dataSet;
    };

    this.ativaFiltroContasReceber = function (args) {
        if (!wasFiltered) {
            var filtroContaReceber = templateManager.container.getWidget('filtroContaReceber');
            ScreenService.openPopup(filtroContaReceber).then(function () {
                filtroContaReceber.activate();
            });
            args.e.preventDefault();
        } else {
            wasFiltered = false;
        }
    };

    this.filtraContasReceber = function (filtroContasReceber) {
        var compensacaoPagar = filtroContasReceber.getParent();
        var contaReceber = compensacaoPagar.getField('CONTARECEBER');
        ScreenService.closePopup(false);
        wasFiltered = true;
        this.aplicaFiltroContasReceber(filtroContasReceber, contaReceber).then(function () {
            contaReceber.reload();
            $("#CONTARECEBER").scope().openField(contaReceber);
        });
    };

    this.aplicaFiltroContasReceber = function (filtroContasReceber, contaReceber) {
        var deferred = ZHPromise.defer();
        //var compensacaoPagar = filtroContasReceber.getParent();
        var clienteConcat, cdfiliemit, cdfilial = '';
        if (!filtroContasReceber.CLIENTEFILTRO) {
            if (filtroContasReceber.currentRow.hasOwnProperty('CLIENTEFILTRO') &&
                filtroContasReceber.currentRow.CLIENTEFILTRO.length > 0){
                    clienteConcat = filtroContasReceber.currentRow.CLIENTEFILTRO.join("_");
            }else{
                clienteConcat = [];
            }
        } else {
            clienteConcat = [];
        }
        if (Array.isArray(filtroContasReceber.getField('CDFILIEMIT').value())) {
            filtroContasReceber.getField('CDFILIEMIT').value().forEach(function (data) {
                cdfiliemit += '_' + data;
            });
            cdfiliemit = (cdfiliemit) ? cdfiliemit + "_" : null;
        }
        if (Array.isArray(filtroContasReceber.getField('CDFILIALANC').value())) {
            filtroContasReceber.getField('CDFILIALANC').value().forEach(function (data) {
                cdfilial += '_' + data;
            });
            cdfilial = (cdfilial) ? cdfilial + "_" : null;
        }
        var valorIni = filtroContasReceber.getField('VRFINALBREC_INI').value();
        var valorFin = filtroContasReceber.getField('VRFINALBREC_FIN').value();
        contaReceber.dataSourceFilter.forEach(function (filtro) {
            switch (filtro.name) {
                case 'CDCLIENTE':
                    filtro.value = (clienteConcat.length != 0) ? clienteConcat : null;
                    break;
                case 'TCDCLIENTE':
                    filtro.value = (clienteConcat.length != 0) ? null : 'T';
                    break;
                case 'DOCINICIAL':
                    filtro.value = filtroContasReceber.getField('DOCINICIAL').value();
                    break;
                case 'DOCFINAL':
                    filtro.value = filtroContasReceber.getField('DOCFINAL').value();
                    break;
                case 'FILIORIG':
                    filtro.value = cdfiliemit;
                    break;
                case 'FILILANC':
                    filtro.value = cdfilial;
                    break;
                case 'CDNOSNUMREC':
                    filtro.value = filtroContasReceber.getField('CDNOSNUMREC').value();
                    break;
                case 'IDPROTESTREC':
                    filtro.value = filtroContasReceber.getField('IDPROTESTREC').value();
                    break;
                case 'DATAINI':
                    filtro.value = filtroContasReceber.getField('DTLANCCOMPPAG').value().start;
                    break;
                case 'DATAFIN':
                    filtro.value = filtroContasReceber.getField('DTLANCCOMPPAG').value().end;
                    break;
                case 'CDTPBAIXAREC':
                    filtro.value = filtroContasReceber.currentRow.CDTPBAIXAREC;
                    break;
                case 'NRDUPLICATA':
                    filtro.value = filtroContasReceber.currentRow.NRDUPLICATA;
                    break;
                case 'STATUS':
                    filtro.value = filtroContasReceber.getField('STATUS').value();
                    break;
                case 'VALORINI':
                    filtro.value = valorIni;
                    break;
                case 'VALORFIN':
                    filtro.value = valorFin;
                    break;
                case 'TVALOR':
                    if (valorIni && valorFin) {
                        if (valorIni == 0 && valorFin == 0) {
                            filtro.value = 'T';
                        } else {
                            filtro.value = null;
                        }
                    } else {
                        filtro.value = 'T';
                    }

                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    this.ativaFiltroContaCorrente = function (args) {
        if (!wasFiltered) {
            var filtroContaCorrente = templateManager.container.getWidget('filtroContaCorrente');
            ScreenService.openPopup(filtroContaCorrente).then(function () {
                filtroContaCorrente.activate();
            });
            args.e.preventDefault();
        }
        else {
            wasFiltered = false;
        }
    };

    this.filtraContaCorrente = function (filtroContaCorrente) {
        var compensacaoPagar = filtroContaCorrente.getParent();
        var contaCorrente = compensacaoPagar.getField('CONTACORRENTE');
        ScreenService.closePopup(false);
        wasFiltered = true;
        this.aplicaFiltroContaCorrente(filtroContaCorrente, contaCorrente).then(function () {
            contaCorrente.reload();
            $("#CONTACORRENTE").scope().openField(contaCorrente);
        });
    };

    this.aplicaFiltroContaCorrente = function (filtroContaCorrente, contaCorrente) {
        var deferred = ZHPromise.defer();
        var compensacaoPagar = filtroContaCorrente.getParent();
        var dataInicial, dataFinal, valorInicial, valorFinal = null;
        var tipoDebito = '';
        if (filtroContaCorrente.currentRow.TIPODEBITO){
            filtroContaCorrente.currentRow.TIPODEBITO.forEach(function (value) {
                tipoDebito += "_" + value;
            });
            tipoDebito = (tipoDebito) ? tipoDebito + "_" : null;
        }
        var contas = '';
        if (!filtroContaCorrente.CONTAFILTRO) {
            if (filtroContaCorrente.currentRow.hasOwnProperty('CONTAFILTRO') &&
                filtroContaCorrente.currentRow.CONTAFILTRO.length > 0){
                filtroContaCorrente.currentRow.CONTAFILTRO.forEach(function (value) {
                    contas += "_" + value;
                });
                contas = (contas) ? contas + "_" : null;
            }else{
                contas = [];
            }
        }else{
            contas = [];
        }
        contaCorrente.dataSourceFilter.forEach(function (data) {
            switch (data.name) {
                case 'CDEMPRESA':
                    data.value = compensacaoPagar.currentRow.CDEMPRESA;
                    break;
                case 'CDREDUCONT':
                    data.value = (contas.length != 0) ? contas : null;
                    break;
                case 'TCDREDUCONT':
                    data.value = (contas.length != 0) ? null : 'T';
                    break;
                case 'DATAINICIAL':
                    dataInicial = (filtroContaCorrente.currentRow.DATALANCAMENTO.start) ? filtroContaCorrente.currentRow.DATALANCAMENTO.start : null;
                    data.value = dataInicial;
                    break;
                case 'DATAFINAL':
                    dataFinal = (filtroContaCorrente.currentRow.DATALANCAMENTO.end) ? filtroContaCorrente.currentRow.DATALANCAMENTO.end : null;
                    data.value = dataFinal;
                    break;
                case 'TDATA':
                    data.value = (dataInicial && dataFinal) ? null : 'T';
                    break;
                case 'VALORINICIAL':
                    valorInicial = (filtroContaCorrente.currentRow.VALORINICIAL) ? filtroContaCorrente.currentRow.VALORINICIAL : null;
                    data.value = valorInicial;
                    break;
                case 'VALORFINAL':
                    valorFinal = (filtroContaCorrente.currentRow.VALORFINAL) ? filtroContaCorrente.currentRow.VALORFINAL : null;
                    data.value = valorFinal;
                    break;
                case 'TVALOR':
                    if (valorInicial && valorFinal) {
                        if (valorInicial == 0 && valorFinal == 0) {
                            data.value = 'T';
                        } else {
                            data.value = null;
                        }
                    } else {
                        data.value = 'T';
                    }

                    break;
                case 'CDTPDEBIBANC':
                    data.value = (tipoDebito) ? tipoDebito : null;
                    break;
                case 'TTIPO':
                    data.value = (tipoDebito) ? null : 'T';
                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    this.setTodasContasCorrentes = function (value) {
        var filtroContaCorrente = templateManager.container.getWidget('filtroContaCorrente');
        filtroContaCorrente.CONTAFILTRO = value;
    };

    this.setTodosClientes = function (value) {
        var filtroContaReceber = templateManager.container.getWidget('filtroContaReceber');
        filtroContaReceber.CLIENTEFILTRO = value;
    };

    this.somaValorCompensarContaCorrente = function (contaCorrente) {
        var compensacao = templateManager.container.getWidget('CompensacaoContasPagar');
        var valorCompensar = 0;
        if (compensacao.isActive()){
            contaCorrente.value().forEach(function (data) {
                valorCompensar += parseFloat(data);
            });
        }else{
            contaCorrente.dataSource.getCheckedRows().forEach(function (data) {
                valorCompensar += parseFloat(data.VRMOVIDEBI);
            });
        }
        compensacao.currentRow.SOMACONTACORRENTE = valorCompensar;
        compensacao.activate();
    };

    this.somaValorCompensarContasReceber = function (contaReceber) {
        var compensacao = templateManager.container.getWidget('CompensacaoContasPagar');
        var valorCompensar = 0;
        if (compensacao.isActive()){
            contaReceber.value().forEach(function (data) {
                valorCompensar += parseFloat(data);
            });
        }else{
            contaReceber.dataSource.getCheckedRows().forEach(function (data) {
                valorCompensar += parseFloat(data.VRFINALBREC);
            });
        }
        compensacao.currentRow.VRTOTALCOMPPAG = valorCompensar;
        compensacao.activate();
    };

    this.cancelarFiltro = function () {
        ScreenService.closePopup();
        templateManager.container.getWidget('CompensacaoContasPagar').activate();
    };

};

Configuration(function (ContextRegister){
    ContextRegister.register('Pag18000_CompensacaoContaPagar_Controller', Pag18000_CompensacaoContaPagar_Controller);
});